//
// OSPException.h
//
// $Id: //poco/1.6/OSP/include/Poco/OSP/OSPException.h#1 $
//
// Library: OSP
// Package: Core
// Module:  OSPException
//
// Definition of the OSPException class.
//
// Copyright (c) 2007-2014, Applied Informatics Software Engineering GmbH.
// All rights reserved.
//
// License: Applied Informatics Software and Source Code License Agreement
//


#ifndef OSP_OSPException_INCLUDED
#define OSP_OSPException_INCLUDED


#include "Poco/OSP/OSP.h"
#include "Poco/Exception.h"


namespace Poco {
namespace OSP {


POCO_DECLARE_EXCEPTION(OSP_API, OSPException, Poco::RuntimeException)
POCO_DECLARE_EXCEPTION(OSP_API, BundleException, OSPException)
POCO_DECLARE_EXCEPTION(OSP_API, ManifestException, BundleException)
POCO_DECLARE_EXCEPTION(OSP_API, BundleStateException, BundleException)
POCO_DECLARE_EXCEPTION(OSP_API, BundleVersionConflictException, BundleException)
POCO_DECLARE_EXCEPTION(OSP_API, BundleLoadException, BundleException)
POCO_DECLARE_EXCEPTION(OSP_API, BundleResolveException, BundleException)


} } // namespace Poco::OSP


#endif // OSP_OSPException_INCLUDED
